#############################################################################
#
# Package: The Invar Tensor Package - version 2.0
#
# Language for this test: Maple.
#
# Description: Test file.
#
# Developers: Renato Portugal
#             Laboratorio Nacional de Computacao Cientifica (LNCC)
#
# Web page: http://www.lnc.br/~portugal/Canon.html
#
# and
#
# Web page: http://www.lnc.br/~portugal/Invar.html
#
# Contact and bug report: Portugal at Lncc.Br
#
#############################################################################

# RiemannSimplify

expr0 := epsilon[a,b,c,d]*Riemann[-a,-b,e,f]*Riemann[-c,-e,-f,g]*
	Riemann[-d,h,i,j]*Ricci[-g,-i]*Ricci[-h,-j]+
	1/8*(epsilon[a,b,c,d]*Riemann[-a,-b,e,f]*Riemann[-c,-d,-e,-f])*
	(Riemann[g,h,i,j]*Ricci[-g,-i]*Ricci[-h,-j]):

expr1 := Riemann[a1,a2,-a1,a3]*Riemann[-a2,a4,-a3,a5]*Riemann[-a4,a6,a7,a8]*
	epsilon[-a5,-a6,-a7,-a8]:

expr2 := Riemann[a1,a2,a3,-a1]*Riemann[-a3,a5,-a2,a4]*Riemann[-a4,a6,a8,a7]*
	epsilon[-a5,-a7,-a8,-a6]:

expr3 := Riemann[a1,a2,-a1,a3]*Riemann[-a2,a4,a5,a6]*Riemann[-a3,-a4,a7,a8]*
	Riemann[-a5,b0,-b0,a9]*epsilon[-a6,-a7,-a8,-a9]+1/2*
	Riemann[a11,a22,-a11,-a22]*Riemann[a1,a2,-a1,a3]*Riemann[-a2,a4,a5,a6]*
	Riemann[-a4,a7,-a7,a8]*epsilon[-a3,-a5,-a6,-a8]-
	1/16*Riemann[a10,a20,-a10,-a20]*Riemann[a11,a22,-a11,-a22]*
	Riemann[a1,a2,a3,a4]*Riemann[-a1,-a2,a5,a6]*epsilon[-a3,-a4,-a5,-a6]:

expr4 := -Ricci[-a2,a3]*Ricci[a5,a2]*Riemann[-a3,a6,a7,a8]*
	Riemann[-a5,-a7,-a6,b0]*Ricci[-a8,-b0]+5/24*RicciS[]^5+
	49/24*RicciS[]^2*Ricci[a3,-a2]*Ricci[a2,a5]*Ricci[-a5,-a3]+
	Ricci[a2,a3]*Riemann[-a2,a4,-a3,a5]*Riemann[-a4,a6,-a5,a7]*
	Ricci[-a6,b0]*Ricci[-a7,-b0]+1/24*RicciS[]^3*
	Riemann[a1,a2,a3,a4]*Riemann[-a1,-a2,-a3,-a4]-5/4*RicciS[]*
	Ricci[a2,a3]*Ricci[-a2,a5]*Ricci[-a3,a7]*Ricci[-a5,-a7]+
	3/4*RicciS[]^2*Ricci[a2,a3]*Riemann[-a2,a4,-a3,a5]*
	Ricci[-a4,-a5]-13/8*RicciS[]^3*Ricci[a2,a3]*Ricci[-a2,-a3]-
	1/2*RicciS[]*Ricci[a2,-a3]*Riemann[-a2,a4,a5,a6]*
	Riemann[a7,a3,-a6,-a5]*Ricci[-a4,-a7]-1/24*Riemann[a3,a4,a1,a2]*
	Riemann[-a1,-a2,-a3,-a4]*Ricci[a20,a30]*Ricci[-a20,a50]*
	Ricci[-a30,-a50]+5/8*RicciS[]*Ricci[a2,a3]*Ricci[-a2,-a3]*
	Ricci[a20,a30]*Ricci[-a20,-a30]:

expr5 := Canon:-CD[-a,a](Riemann[a3,a5,a1,a0])*Riemann[-a3,a2,-a1,a4]*
	epsilon[-a5,-a0,-a2,-a4]+
	Canon:-CD[a](Riemann[a3,a5,a1,a0])*Canon:-CD[-a](Riemann[-a3,a2,-a1,a4])*
	epsilon[-a5,-a0,-a2,-a4]+
	Canon:-CD[-a](Riemann[a3,a5,a1,a0])*Canon:-CD[a](Riemann[-a3,a2,-a1,a4])*
	epsilon[-a5,-a0,-a2,-a4]+
	Riemann[a3,a5,a1,a0]*Canon:-CD[-a,a](Riemann[-a3,a2,-a1,a4])*
	epsilon[-a5,-a0,-a2,-a4]-
	Canon:-CD[a,-a](Riemann[a3,a5,a1,a0]*Riemann[-a3,a2,-a1,a4]*
	epsilon[-a5,-a0,-a2,-a4])-
	Canon:-CD[-a,a](Riemann[a3,a1,-a3,a0])*Riemann[-a1,a2,-a0,-a2]-
	Canon:-CD[a](Riemann[a3,a1,-a3,a0])*
	Canon:-CD[-a](Riemann[-a1,a2,-a0,-a2])-Canon:-CD[-a](Riemann[a3,a1,-a3,a0])*
	Canon:-CD[a](Riemann[-a1,a2,-a0,-a2])-Riemann[a3,a1,-a3,a0]*
	Canon:-CD[-a,a](Riemann[-a1,a2,-a0,-a2])+Metric[a,b]*
	Canon:-CD[-b,-a](Riemann[a3,a1,-a3,a0]*Riemann[-a1,a2,-a0,-a2]):


# cyclic symmetries

expr6 := RInv[2,3] - 1/2*RInv[2,2] - RInv[3,6] + 1/2*RInv[3,5]:

expr7 := - RInv[4,38] + 1/4*RInv[4,23]-RInv[4,26]+RInv[4,36]:

expr8 := RInv[6,31] -RInv[5,203] -RInv[5,200]+RInv[5,201] - 1/4*RInv[6,27]:

expr9 := - RInv[6,1575] + 3/4*RInv[6,1219]+1/2*RInv[6,1223]+
	RInv[6,1572]-3/2*RInv[6,1221]:

expr10 := RInv[7,15138] - 1/2*RInv[7,12749] - RInv[6,1524] + 
	RInv[6,1523]-1/2*RInv[6,1161]:

expr11 := -RInv[7,16207] -1/4*RInv[7,12848]+RInv[7,16206]:

expr12 := -RInv[[0,2,4],31045] - RInv[[0, 2, 4],30725]:

expr13 := DualRInv[2,1]+DualRInv[3,1]:

expr14 := - DualRInv[3,27] -1/4*DualRInv[3,14]+1/2*DualRInv[3,23] + 
	DualRInv[4,1] - DualRInv[4,3] + 1/2*DualRInv[4,2] -7*DualRInv[4,9] + 
	DualRInv[4,11] - 1/2*DualRInv[4,10]:

expr15 := DualRInv[4,231] + DualRInv[4,232] + DualRInv[5,1] + 
	DualRInv[5,3] - 1/2*DualRInv[5,2] + 10*DualRInv[5,8] + 
	DualRInv[5,9] - DualRInv[5,10]:

expr16 := -DualRInv[[2,2],306] -1/2*DualRInv[[2, 2],272]+1/2*
	DualRInv[[2, 2],298]:

expr17 := RInv[[1, 1, 4], 15073] + 1/4*RInv[[1, 1, 4], 15063] - 
	RInv[[1, 1, 4], 15072]:

expr18 := DualRInv[[1, 3], 914] - 1/4*DualRInv[[1, 3], 908]:

expr19 := RInv[[0, 0, 0, 1, 1], 27015] + 2*RInv[[0, 0, 0, 1, 1], 26365]:

expr20 := RInv[[8], 1116] + RInv[[8], 1092] - RInv[[8], 1115]:

# Bianchi symmetries

expr21 :=  RInv[[1, 1, 4],15073]+1/4*RInv[[1, 1, 4],15063]-RInv[[1, 1, 4],15072]:

expr22 :=  DualRInv[[1, 3],914]-1/4*DualRInv[[1, 3],908]:

expr23 := RInv[[0, 0, 0, 1, 1],27015]+2*RInv[[0, 0, 0, 1, 1],26365]:

expr24 :=  RInv[[8],1116]+RInv[[8],1092]-RInv[[8],1115]:

expr25 :=  RInv[[1, 1, 4],15072]-RInv[[1, 1, 4],1750]+RInv[[1, 1, 4],1751]-\
        2*RInv[[1, 1, 4],1753]-RInv[[1, 1, 4],1754]:

expr26 :=  DualRInv[[1, 3],908]+4*DualRInv[[1, 3],328]-4*DualRInv[[1, 3],332]:

expr27 :=  RInv[[0, 0, 0, 1, 1],26365]+4*RInv[[0, 0, 0, 1, 1],26327]-4*RInv\
        [[0, 0, 0, 1, 1],26335]:

expr28 :=   RInv[[8],1092]+RInv[[8],1090]-RInv[[8],1091]:

# Commuting Covariant Derivative

expr29 :=   RInv[[0, 0, 4],70]-RInv[[0, 0, 0, 2],50]-RInv[[0, 0, 1, 1],100]:

expr30 :=  -8*RInv[[0, 0, 0, 0, 0],36]-8*RInv[[0, 0, 0, 0, 0],38]-8*RInv[[0\
        , 0, 0, 0, 0],43]-8*RInv[[0, 0, 0, 0, 0],45]+8*RInv[[0, 0,\
         0, 0, 0],35]-4*RInv[[0, 0, 0, 2],42]+4*RInv[[0, 0, 0, 0, \
        0],2]+4*RInv[[0, 0, 1, 1],71]-4*RInv[[0, 0, 1, 1],251]-4*
         RInv[[0, 0, 1, 1],264]+4*RInv[[0, 0, 1, 1],267]-2*RInv[[0, \
        0, 0, 2],5]+4*RInv[[0, 0, 0, 2],6]-2*RInv[[0, 0, 0, 2],8]-\
        2*RInv[[0, 0, 0, 2],12]-4*RInv[[0, 0, 0, 2],31]+8*RInv[[0,\
         0, 0, 2],32]-4*RInv[[0, 0, 0, 2],34]+8*RInv[[0, 0, 0, 2],\
        35]+8*RInv[[0, 0, 0, 2],37]-4*RInv[[0, 0, 0, 2],41]+10*
        RInv[[0, 0, 0, 0, 0],6]+4*RInv[[0, 0, 0, 0, 0],8]-4*RInv[[0, \
        0, 0, 0, 0],9]+8*RInv[[0, 0, 0, 0, 0],11]+6*RInv[[0, 0, 0,\
         0, 0],12]+4*RInv[[0, 0, 0, 0, 0],25]+4*RInv[[0, 0, 0, 0, \
        0],27]+8*RInv[[0, 0, 0, 0, 0],31]+8*RInv[[0, 0, 0, 0, 0],33]-
        RInv[[0, 0, 4],74]+2*RInv[[0, 0, 4],18]-2*RInv[[0, 0, 4\
        ],19]:

expr31 :=  -DualRInv[[1, 3],11]+DualRInv[[1, 3],10]+DualRInv[[0, 1, 1],2]-
        DualRInv[[0, 1, 1],4]-2*DualRInv[[0, 1, 1],6]+DualRInv[[0, \
        1, 1],88]-2*DualRInv[[0, 1, 1],89]:

expr32 :=  DualRInv[[1, 3],5]-DualRInv[[0, 1, 1],1]-1/2*DualRInv[[0, 1, 1],\
        18]:

# Dimension Dependent Identities

expr33 :=  -RInv[[1, 2, 3],5861]+1/8*RInv[[1, 2, 3],7]+1/4*RInv[[1, 2, 3],
       49]+1/2*RInv[[1, 2, 3],380]-1/2*RInv[[1, 2, 3],392]-1/2*
       RInv[[1, 2, 3],474]+1/2*RInv[[1, 2, 3],480]-1/2*RInv[[1, 2, 3\
        ],625]+1/2*RInv[[1, 2, 3],631]+RInv[[1, 2, 3],1356]-2*
        RInv[[1, 2, 3],1362]+RInv[[1, 2, 3],1380]-RInv[[1, 2, 3],1416]\
        +RInv[[1, 2, 3],1422]-1/2*RInv[[1, 2, 3],2229]+1/2*RInv[[1\
        , 2, 3],2626]-2*RInv[[1, 2, 3],4985]-RInv[[1, 2, 3],5804]+\
        RInv[[1, 2, 3],5816]+RInv[[1, 2, 3],5837]:

expr34 := DualRInv[[0, 0, 2],95]+1/4*DualRInv[[0, 0],2]*RInv[[2],1]:

expr35 :=  -RInv[[0, 3, 3],3901]+1/8*RInv[[0],1]*RInv[[3, 3],7]-1/2*RInv[[0\
        ],1]*RInv[[3, 3],150]+1/2*RInv[[0],1]*RInv[[3, 3],155]-1/4\
        *RInv[[0, 3, 3],14]-RInv[[0, 3, 3],101]-RInv[[0, 3, 3],111\
        ]-2*RInv[[0, 3, 3],585]+RInv[[0, 3, 3],590]+2*RInv[[0, 3, \
        3],602]+RInv[[0, 3, 3],718]+RInv[[0, 3, 3],1144]+RInv[[0, \
        3, 3],3567]-2*RInv[[0, 3, 3],3572]+2*RInv[[0, 3, 3],3875]:

expr36 :=  DualRInv[[0, 1, 1],4]+1/2*DualRInv[[0, 1, 1],1]+DualRInv[[0, 1, \
        1],2]-DualRInv[[0, 1, 1],3]:

# dimension dependent relations

expr37 := - RInv[3,3] + 1/4*RInv[1,1]^3-2*RInv[3,1]+1/4*RInv[1,1]*
	RInv[2,2]+2*RInv[3,2]-2*RInv[1,1]*RInv[2,1]:

expr38 := - RInv[4,36] - 4/3*RInv[1,1]*RInv[3,1]-1/4*RInv[2,1]*RInv[2,2]-
	3*RInv[4,1]+4*RInv[4,7]+RInv[4,5]-1/4*RInv[4,21]+3/4*RInv[1,1]^2*
	RInv[2,1]-3*RInv[1,1]*RInv[3,2]+1/4*RInv[1,1]*RInv[3,5]-
	1/12*RInv[1,1]^4-1/8*RInv[1,1]^2*RInv[2,2]+1/8*RInv[2,2]^2 - 
	RInv[5,1] + 1/24*RInv[1,1]^5-5/6*RInv[1,1]^2*RInv[3,1]+
	5/8*RInv[1,1]*RInv[2,1]^2-5/4*RInv[1,1]*RInv[4,1]-
	5/12*RInv[1,1]^3*RInv[2,1]+5/6*RInv[2,1]*RInv[3,1]:

expr39 := - RInv[6,108] - 31/24*RInv[1,1]^3*RInv[3,1]-11/16*RInv[1,1]^4*
	RInv[2,1]+1/12*RInv[1,1]^6-7/8*RInv[1,1]^2*RInv[4,1]+7/16*
	RInv[1,1]^2*RInv[2,1]^2+1/8*RInv[1,1]^3*RInv[3,2]-RInv[1,1]*
	RInv[5,2]+1/2*RInv[6,47]+RInv[6,13]+RInv[3,1]^2-RInv[3,1]*
	RInv[3,2]+1/8*RInv[3,1]*RInv[3,5]+1/4*RInv[1,1]*RInv[2,1]*
	RInv[3,2]+3/2*RInv[1,1]*RInv[2,1]*RInv[3,1]-1/8*RInv[1,1]*
	RInv[2,2]*RInv[3,1]:

expr40 := -RInv[7,7490] + 1/64*RInv[1,1]*RInv[2,2]*RInv[4,21]+1/2*
	RInv[7,2190]-3/8*RInv[1,1]*RInv[2,2]*RInv[4,1]+1/12*RInv[2,1]*
	RInv[2,2]*RInv[3,1]-23/48*RInv[1,1]^2*RInv[2,2]*RInv[3,1]+
	3/8*RInv[1,1]*RInv[2,1]^2*RInv[2,2]-31/96*RInv[1,1]^3*
	RInv[2,1]*RInv[2,2]-1/2*RInv[1,1]*RInv[2,1]*RInv[4,1]-
	11/12*RInv[1,1]^2*RInv[2,1]*RInv[3,1]-1/16*RInv[1,1]*
	RInv[2,1]*RInv[2,2]^2-2*RInv[7,14]+1/192*RInv[1,1]^3*
	RInv[2,2]^2+5/12*RInv[1,1]^3*RInv[4,1]-1/3*RInv[3,1]*
	RInv[4,1]-11/288*RInv[1,1]^7-25/48*RInv[1,1]^3*RInv[2,1]^2+
	35/96*RInv[1,1]^5*RInv[2,1]+79/144*RInv[1,1]^4*
	RInv[3,1]+1/6*RInv[2,1]^2*RInv[3,1]-4/9*RInv[1,1]*
	RInv[3,1]^2+7/192*RInv[1,1]^5*RInv[2,2]-1/24*
	RInv[2,2]^2*RInv[3,1]-2*RInv[7,55]-1/192*RInv[1,1]^3*
	RInv[4,21]-2*RInv[1,1]*RInv[6,47]-3/4*RInv[1,1]^2*
	RInv[5,33]+1/2*RInv[3,2]*RInv[4,1]-1/6*RInv[1,1]^4*
	RInv[3,2]-1/4*RInv[2,1]^2*RInv[3,2]+1/4*RInv[1,1]^2*
	RInv[5,2]-1/3*RInv[3,1]*RInv[4,5]+1/6*RInv[1,1]^3*
	RInv[4,5]-3/4*RInv[1,1]^2*RInv[5,8]+1/24*RInv[3,1]*
	RInv[4,21]-3/4*RInv[2,2]*RInv[5,2]-1/2*RInv[1,1]*
	RInv[2,1]*RInv[4,5]+5/6*RInv[1,1]*RInv[3,1]*
	RInv[3,2]+1/2*RInv[1,1]^2*RInv[2,1]*RInv[3,2]+
	1/16*RInv[1,1]^2*RInv[2,2]*RInv[3,2]+1/4*RInv[2,2]*
	RInv[5,8]+1/16*RInv[2,2]^2*RInv[3,2]-2*RInv[1,1]*
	RInv[6,13]+RInv[2,1]*RInv[5,2]+1/4*RInv[2,2]*RInv[5,33]:

expr41 := -DualRInv[3,23] +1/2*DualRInv[3,13]+DualRInv[3,2]-
	3/8*RInv[1,1]*DualRInv[2,2]- DualRInv[4,2] - 
	1/2*RInv[1,1]*DualRInv[3,2]:

expr42 := - DualRInv[5,1770] + 5/32*RInv[1,1]^3*DualRInv[2,2]-
	9/8*RInv[1,1]*RInv[2,1]*DualRInv[2,2]+3/32*RInv[1,1]*
	RInv[2,2]*DualRInv[2,2]-RInv[3,1]*DualRInv[2,2]+3/4*
	RInv[3,2]*DualRInv[2,2]-1/16*RInv[3,5]*DualRInv[2,2] - 
	DualRInv[5,1404] -1/8*RInv[2,2]*DualRInv[3,13]:

# signature dependent identities - DualDual Identities

expr43 :=  3/8*RInv[[1, 1],1]*RInv[[1, 1],4]-3/8*RInv[[1, 1],1]*RInv[[1, 1]\
        ,5]+5/2*RInv[[1, 1],4]*RInv[[1, 1],5]+2*RInv[[1, 1, 1, 1],\
        40]+6*RInv[[1, 1, 1, 1],41]-4*RInv[[1, 1, 1, 1],42]-RInv[[\
        1, 1, 1, 1],43]-RInv[[1, 1, 1, 1],44]+1/2*RInv[[1, 1, 1, 1\
        ],45]+3/2*RInv[[1, 1, 1, 1],46]-1/4*DualRInv[[1, 1],1]^2-1\
        /64*RInv[[1, 1],1]^2-RInv[[1, 1, 1, 1],53]-5/4*RInv[[1, 1]\
        ,4]^2-5/4*RInv[[1, 1],5]^2-1/4*RInv[[1, 1, 1, 1],3]+1/4*
         RInv[[1, 1, 1, 1],5]+RInv[[1, 1, 1, 1],12]-RInv[[1, 1, 1, 1]\
        ,14]-RInv[[1, 1, 1, 1],15]-RInv[[1, 1, 1, 1],16]+RInv[[1, \
        1, 1, 1],20]-2*RInv[[1, 1, 1, 1],22]-RInv[[1, 1, 1, 1],23]\
        -3*RInv[[1, 1, 1, 1],38]+2*RInv[[1, 1, 1, 1],39]:

expr44 :=  RInv[[0, 0, 1, 1],1104]-1/4*DualRInv[[0, 0],2]*DualRInv[[1, 1],25]-
          1/2*RInv[[0, 0, 1, 1],1098]:

expr45 :=  -RInv[[0, 0, 1, 3],25986]+1/8*DualRInv[[0, 0],2]*DualRInv[[1, 3]\
        ,294]+1/8*DualRInv[[0, 0],2]*DualRInv[[0, 1, 1],1]+1/4*
         DualRInv[[0, 0],2]*DualRInv[[0, 1, 1],2]+3/32*DualRInv[[0, 0]\
        ,2]*DualRInv[[0, 1, 1],18]+1/8*DualRInv[[0, 0],2]*
        DualRInv[[0, 1, 1],63]-1/2*DualRInv[[0, 0],2]*DualRInv[[0, 1, 1],
        86]+5/8*DualRInv[[0, 0],2]*DualRInv[[0, 1, 1],87]+1/16*
        DualRInv[[0, 0],2]*DualRInv[[0, 1, 1],97]+1/32*DualRInv[[0, 0]\
        ,2]*DualRInv[[0, 1, 1],117]+3/16*DualRInv[[0, 0],2]*
        DualRInv[[0, 1, 1],271]-1/16*DualRInv[[0, 0],2]*DualRInv[[1, 1],\
        1]*RInv[[0],1]+1/2*RInv[[0, 0, 1, 3],25974]:


expr46 :=  -RInv[[0, 0, 2, 2],5470]-1/8*DualRInv[[0, 0],2]*DualRInv[[2, 2],\
        19]-1/4*DualRInv[[0, 0],2]*DualRInv[[0, 0, 2],2]+1/16*
        DualRInv[[0, 0],2]*DualRInv[[0, 0, 2],5]-1/16*DualRInv[[0, 0],\
        2]*DualRInv[[0, 0, 2],14]+1/4*DualRInv[[0, 0],2]*DualRInv[\
        [0, 0, 2],32]-1/16*DualRInv[[0, 0],2]*DualRInv[[0, 2],15]*\
        RInv[[0],1]+1/16*DualRInv[[0, 0],2]*DualRInv[[0, 0, 0],2]*\
        RInv[[0],1]-1/128*DualRInv[[0, 0],2]^2*RInv[[0],1]^2+1/32*\
        DualRInv[[0, 0],2]^2*RInv[[0, 0],1]-RInv[[0, 0, 2, 2],5461\
        ]+RInv[[0, 0, 2, 2],5466]:

expr47 := - RInv[5,123] + 5*CanonMetricDet*DualRInv[2,2]*DualRInv[3,2]/24+
	5*CanonMetricDet*DualRInv[2,2]*DualRInv[3,13]/48-2*RInv[1,1]^5/3+25*
	RInv[1,1]^3*RInv[2,1]/6+15*RInv[1,1]*RInv[2,1]^2/2-5*RInv[1,1]*
	RInv[2,1]*RInv[2,2]/2+15*RInv[1,1]^2*RInv[3,1]/2+10*RInv[2,1]*
	RInv[3,1]/3-5*RInv[2,2]*RInv[3,1]/6-5*RInv[1,1]^2*RInv[3,2]/2-
	10*RInv[2,1]*RInv[3,2]+5*RInv[2,2]*RInv[3,2]/2+5*RInv[1,1]^2*
	RInv[3,5]/12-5*RInv[2,1]*RInv[3,5]/6+5*RInv[2,2]*RInv[3,5]/12+
	5*RInv[1,1]*RInv[4,1]+20*RInv[5,8]+20*RInv[5,33]:

# WeylToRiemann and RiemannToWeyl

expr48 := Weyl[a,b,c,d]-Riemann[a,b,c,d]-1/2*Metric[a,d]*Ricci[b,c]-
	1/2*Metric[b,c]*Ricci[a,d]+1/2*Metric[a,c]*Ricci[b,d]+1/2*Metric[b,d]*
	Ricci[a,c]-1/6*RicciS[]*(Metric[a,c]*Metric[b,d]-Metric[a,d]*Metric[b,c]):

# RiemannToRicci

expr49 := Riemann[c,d,-c,-d]*Riemann[a,f,b,-f]*Riemann[-a,-b,h,l]*
	Metric[-h,-l]-RicciS[]*Ricci[a,b]*Riemann[-a,-b,h,l]*Metric[-h,-l]:

# InvToRiemann and RiemannToInv

expr50 := RInv[7,306]-Riemann[a2,i1,-a2,i2]*Riemann[-i1,i3,-i3,i4]*
	Riemann[-i2,i5,i6,i7]*Riemann[-i4,i8,i9,i10]*
	Riemann[-i5,a1,-i8,-a1]*Riemann[-i6,a4,-i9,a3]*
	Riemann[-i7,-a4,-i10,-a3]:

expr51 := RInv[1,1]*DualRInv[2,1]-(Riemann[i11,i22,-i11,-i22])*
	(Riemann[i1,i2,-i1,i3]*Riemann[-i2,i4,i5,i6]*
	epsilon[-i3,-i4,-i5,-i6]):

expr52 := DualRInv[2,3]^2-(Riemann[a1,a2,a4,a3]*Riemann[-a1,-a4,a6,a5]*
	epsilon[-a2,-a3,-a6,-a5])*(Riemann[a10,a20,a40,a30]*
	Riemann[-a10,-a40,a60,a50]*epsilon[-a20,-a30,-a60,-a50]):

expr53 := RInv[3,3]*DualRInv[5,2]-(Riemann[i10,i20,-i10,i30]*
	Riemann[-i20,i40,i50,i60]*Riemann[-i30,-i40,-i50,-i60])*
	(Riemann[a2,i1,-a2,i2]*Riemann[-i1,i3,-i3,i4]*
	Riemann[-i2,i5,-i5,i6]*Riemann[-i4,i7,i8,i9]*
	Riemann[-i7,i10,-i10,a1]*epsilon[-i6,-i8,-i9,-a1]):

expr54 := RInv[6,137]+2*DualRInv[5,289]-Riemann[a2,i1,-a2,i2]*
	Riemann[-i1,i3,-i3,i4]*Riemann[-i2,i5,i6,i7]*
	Riemann[-i4,i8,-i6,i9]*Riemann[-i5,-i8,i10,a1]*
	Riemann[-i7,-i10,-i9,-a1]-2*(Riemann[a2,i1,-a2,i2]*
	Riemann[-i1,i3,i4,i5]*Riemann[-i2,i6,-i4,i7]*
	Riemann[-i3,i8,-i7,i9]*Riemann[-i8,i10,-i10,a1]*
	epsilon[-i5,-i6,-i9,-a1]):

expr55 := RInv[[0, 2, 2],1157]-
	Riemann[a7,a6,a5,a2]*Canon:-CD[-a1,a4](Riemann[-a7,-a6,a1,a0])*
	Canon:-CD[-a0,-a3](Riemann[-a5,-a4,-a2,a3]):

expr56 := DualRInv[[0,4],2]-
	Riemann[a1,a2,-a1,a4]*Canon:-CD[a7,a5,-a2,a6](Riemann[a0,a3,-a0,-a3])*
	epsilon[-a4,-a6,-a5,-a7]:

#
# All expr must return 0
#

settime := time():

Weyl := C:
Riemann := R:
Ricci := R:
RicciS := R:
Metric := g:

for ii from 0 to 47 do 
  if Canon:-RiemannSimp(expr||ii)=0 then 
      lprint(ii=ok)
  else
      lprint(ii="error")
  end if;
od;

for ii from 48 to 48 do 
  if Canon:-WeylToRiemann(expr||ii)=0 and 
     expand(Canon:-RiemannToWeyl(expr||ii))=0 then 
      lprint(ii=ok) 
  else
      lprint(ii="error")
  end if;
od;

for ii from 49 to 49 do 
  if Canon:-RiemannToRicci(expr||ii)=0 then 
      lprint(ii=ok) 
  else
      lprint(ii="error")
  end if;
od;

for ii from 50 to 56 do 
  if Canon:-Canonical(Canon:-InvToRiemann(expr||ii))=0 and 
     Canon:-Canonical(Canon:-RiemannToInv(expr||ii))=0 then 
      lprint(ii=ok) 
  else
      lprint(ii="error")
  end if;
od;

unassign(seq(evaln(expr||ii),ii=0..56));
unassign('Weyl,Riemann,Ricci,RicciS,Metric');
 
lprint(total_time=time()-settime);

unassign('ii,settime');





